image: docker:19.03.13-dind
stages:
  - build
  - deploy

build_image:
  stage: build
  except:
    - tags
  tags: 
    - chk-docker
  services:
    - docker:19.03.13-dind
  variables:
    IMAGE_TAG: calvin.ho/strapi-backend:prod
    DOCKER_TLS_CERTDIR: ""
  script:
    - echo -e "HOST=$HOST\nPORT=$PORT\nADMIN_JWT_SECRET=$ADMIN_JWT_SECRET\nINSTANCE_CONNECTION_NAME=$INSTANCE_CONNECTION_NAME\nDATABASE_NAME=$DATABASE_NAME\nDATABASE_USERNAME=$DATABASE_USERNAME\nDATABASE_PASSWORD=$DATABASE_PASSWORD\nSMTP_HOST_USER=$SMTP_HOST_USER\nSMTP_HOST_PW=$SMTP_HOST_PW" >> .env
    - export BUILD_ARGS=$(for arg in $(cat .env.example); do echo "--build-arg $arg ";done | tr -d '\n');
    - docker login -u $CI_REGISTRY_USER_DOCKER -p $CI_REGISTRY_PASSWORD_DOCKER $CI_REGISTRY 
    - docker build --cache-from $CI_REGISTRY/calvin.ho/strapi-backend:prod $BUILD_ARGS --build-arg configuration=production -t $CI_REGISTRY/calvin.ho/strapi-backend:prod .
    - docker push $CI_REGISTRY/calvin.ho/strapi-backend:prod
    
deploy:
  stage: deploy
  tags: 
    - chk-docker
  services:
    - docker:19.03.13-dind
  script:
    - apk add --no-cache rsync openssh sshpass
    - mkdir -p ~/.ssh
    - echo "$SSH_PRIVATE_KEY" >> ~/.ssh/id_dsa
    - chmod 600 ~/.ssh/id_dsa
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config 
    - sshpass -p ${SSH_PK_PW} ssh ${SSH_HOSTNAME} "docker login registry.gitlab.com -u DockerToken -p ${CI_REGISTRY_PASSWORD_DOCKER} && docker pull registry.gitlab.com/calvin.ho/strapi-backend:prod && docker stop strapi-backend && docker rm -f strapi-backend &&  docker run -d --name strapi-backend -v /docker/mariadb/strapi/public:/usr/src/app/public -p 1337:1337 registry.gitlab.com/calvin.ho/strapi-backend:prod"
